import time

# open the file and load in all integers into a list
#
with open("0059_cipher.txt","r") as fid:
    ciphertext = fid.readlines()[0].split(',')

print(f"ciphertext is {len(ciphertext)} chars long")
print(f"the first 10 are {ciphertext[:10]}")

# define function to encrypt/decrypt a message using a key with XOR
#
def crypt(message, key):
    """
    crypt(message, key) applies XOR bitwise to each char in message (int)
                        using the chars in key (str) and returns the (de/en)crypted
                        message (str); assumes key is shorter than message
    """
    message2 = "" # string starts out empty
    for i in range(len(message)):
        message2 += chr( int(message[i]) ^ ord(key[i % len(key)]) )
    return message2

# loop through all possible keys and decrypt
#
letters = "abcdefghijklmnopqrstuvwxyz" # we know the key is lower-case letters only
n = 1
nn = 26*26*26
solutions = []
t1 = time.time()
for c1 in letters:
    for c2 in letters:
        for c3 in letters:
            print(f"\r{n}/{nn}", end=" ")
            n = n + 1
            key = c1 + c2 + c3
            message2 = crypt(ciphertext, key)
            ok = message2.find(' the ') >= 0
            if ok:
                solutions.append({"n": n, "key": key, "message": message2})
t2 = time.time()
print(f"\nelapsed time: {t2-t1:.3f} sec")
print(f"found {len(solutions)} potential solution(s)")

# look at all the potential solutions
#
for i in range(len(solutions)):
    n = solutions[i]["n"]
    key = solutions[i]["key"]
    message = solutions[i]["message"]
    print(f"n: {n}")
    print(f"key: {key}")
    print(f"message: {message}")
    print("---")
